; Written by: RuiLoureiro
;
include \masm32\include\masm32rt.inc
.686p

;  CONSOLE ASSEMLBLE & LINK 

CreateLkdList       proto   :DWORD,:DWORD,:DWORD,:DWORD
FormatLkdList       proto   :DWORD,:DWORD,:DWORD

DestroyLkdList      proto   :DWORD

InsertLkdList       proto   :DWORD,:DWORD,:DWORD
DeleteLkdList       proto   :DWORD,:DWORD,:DWORD

VerifyLkdList       proto   :DWORD,:DWORD

AddStrLkdList       proto   :DWORD,:DWORD,:DWORD,:DWORD
AddIntLkdList       proto   :DWORD,:DWORD,:DWORD,:DWORD

NODE1       struct
   iNext   dd ?
   iPrev   dd ?
   LkdData db 80 dup (?) 
NODE1       ends

NODE       struct
   iNext   dd ?
   iPrev   dd ?
   LkdData db 80 dup (?)
   StrData db 40 dup (?)
   IntData dd ?      
NODE       ends


PTRNEWLIST      equ 20
IDXNODLIST      equ 16
IDXFSTLIST      equ 12
IDXLSTLIST      equ 8
IDXALCLIST      equ 4

LENNODE         equ sizeof NODE
;
.data

    Val1        dd 1
    Val2        dd 2

    Str1        db "Frut 1", 0
    Str2        db "Frut 2", 0
    Str3        db "Frut 3", 0
    Str4        db "Frut 4", 0
    Str5        db "Frut 5", 0
    Str6        db "Frut 6", 0
    Str7        db "Frut 7", 0
    Str8        db "Frut 8", 0
    Str9        db "Frut 9", 0
    Str10       db "Frut 10", 0
    Str11       db "Frut 11", 0
    Str12       db "Frut 12", 0
    Str13       db "Frut 13", 0
    Str14       db "Frut 14", 0
    Str15       db "Frut 15", 0
    Str16       db "Frut 16", 0
    Str17       db "Frut 17", 0
    Str18       db "Frut 18", 0
    Str19       db "Frut 19", 0
    Str20       db "Frut 20", 0
    Str21       db "Frut 21", 0
    Str22       db "Frut 22", 0
    

    Frut1       db "orange", 0
    Frut2       db "melon", 0           ; = Frut9
    Frut3       db "quince", 0
    Frut4       db "apricot", 0
    Frut5       db "strawberry", 0
    Frut6       db "peach", 0
    Frut7       db "grape", 0
    Frut8       db "apple", 0
    Frut9       db "melon", 0           ; = Frut2
    Frut10      db "cherry", 0
    Frut11      db "almond", 0
    Frut12      db "lemon", 0
    Frut13      db "pear", 0
    Frut14      db "mulberry", 0
    Frut15      db "banana", 0
    Frut16      db "loquat", 0
    Frut17      db "walnut", 0
    Frut18      db "mango", 0
    Frut19      db "fig", 0
    Frut20      db "passion-fruit", 0
    Frut21      db "pineapple", 0
    Frut22      db "chestnut", 0
    
.data?
   pBuffer      dd ?        ; the address of memory alloc to linked list
   pList        dd ?        ; the address of the linked list 
;
.code

start:

        invoke   CreateLkdList, 20, sizeof NODE, addr pBuffer, addr pList
        jc       _exit

        ;call     SeeLkdList
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut1
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str1
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, Val1

        invoke   InsertLkdList, pList, sizeof NODE, addr Frut2
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str2
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, Val2
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut3
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str3
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 3
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut4
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str4
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 4
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut5
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str5
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 5
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut6
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str6
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 6
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut7
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str7
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 7
        
        ; plus
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut8
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str8
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 8
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut9
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str9
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 9
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut10
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str10
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 10
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut11
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str11
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 11
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut12
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str12
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 12
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut13
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str13
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 13
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut14
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str14
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 14
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut15
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str15
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 15
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut16
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str16
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 16
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut17
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str17
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 17
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut18
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str18
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 18
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut19
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str19
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 19
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut20
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str20
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 20
        

        ;invoke   InsertLkdList, pList, sizeof NODE, addr Frut21       ; only 20

        call     ShowLkdListDn
        call     ShowLkdListUp
        call     VerifyList

        print   "DELETE melon, strawberry, apricot ", 13, 10

        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut2
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut5
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut4
        ;invoke   DeleteLkdList, pList, sizeof NODE, addr Frut21     ; doesnt exist

        call     ShowLkdListDn
        call     ShowLkdListUp
        call     VerifyList

        call     ShowAlloc

        print   "INSERT melon, strawberry, apricot ", 13, 10

        invoke   InsertLkdList, pList, sizeof NODE, addr Frut2
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str2
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, Val2
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut4
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str4
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 4
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut5
        invoke   AddStrLkdList, pList, sizeof NODE, NODE.StrData, addr Str5
        invoke   AddIntLkdList, pList, sizeof NODE, NODE.IntData, 5


        call     ShowLkdListDn
        call     ShowLkdListUp
        call     VerifyList

        call     ShowAlloc
;----------------------------------
        print   "DELETE ALL but one", 13, 10
        ;invoke  FormatLkdList, 20, sizeof NODE, pList      ; to delete all


        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut1
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut2
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut3        
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut4
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut5
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut6
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut7
        ;
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut8
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut9
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut10
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut11
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut12
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut13
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut14
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut15
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut16
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut17
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut18
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut19
        ;invoke   DeleteLkdList, pList, sizeof NODE, addr Frut20        
        
        call     ShowLkdListDn
        call     ShowLkdListUp
        call     VerifyList

        call     ShowAlloc

        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut20        
        call     ShowAlloc
        call     VerifyList

   ;---------------------
_exit:
        inkey
        invoke   DestroyLkdList, pBuffer

        exit
;
VerifyLkdList       proc    pLst:DWORD, lReg:DWORD
                    LOCAL   nNodeDn, nNodeUp, IdxCur:DWORD
                    push    ebx
                    push    edi
                    ;
                    mov     nNodeDn, 0
                    mov     nNodeUp, 0
                    
                    mov     edi, pLst
                    mov     ebx, dword ptr [edi - IDXNODLIST]         ; Nodes
                    
                    mov     edx, dword ptr [edi - IDXLSTLIST]
                    mov     eax, dword ptr [edi - IDXFSTLIST]
                    cmp     eax, 0
                    je      short _lst
                    ;
                    cmp     edx, 0
                    jne     short @F
                    je      short _erro

        _lst:       cmp     edx, 0
                    je      _fim
                    ;
                    ; Error
                    ; -----
    _erro:          invoke  MessageBeep, MB_ICONASTERISK
                    stc
                    jmp     _end
    ;***---***
        _case1:     cmp     ecx, 0
                    jne     short _erro

                    mov     eax, dword ptr [edi - IDXLSTLIST]
                    cmp     eax, dword ptr [edi - IDXFSTLIST]
                    jne     short _erro
                    je      short _Up
                    
        _case2:     cmp     ecx, 0
                    jne     short _erro

                    mov     eax, dword ptr [edi - IDXLSTLIST]
                    cmp     eax, dword ptr [edi - IDXFSTLIST]
                    jne     short _erro
                    je      short _fim
    ;***---***                    
        _NextDn:    mov     eax, ecx        ;IdxNxt        
                    cmp     eax, 0
                    je      short _Up
                    ;
    @@:             mov     IdxCur, eax
    
                    sub     eax, 1
                    mov     edx, lReg
                    mul     edx
                    add     eax, edi
                    ;
                    mov     ecx, dword ptr [eax].NODE.iNext         ; Idx Next
                    mov     edx, dword ptr [eax].NODE.iPrev         ; Idx Prev

                    add     nNodeDn, 1
                    cmp     ebx, nNodeDn
                    jb      _erro
                    ;
                    cmp     ecx, IdxCur 
                    je      _erro
                    ;
                    cmp     edx, IdxCur 
                    je      _erro

                    cmp     ecx, edx
                    je      short _case1
                    jne     short _NextDn
    ;***---***
        _Up:        mov     eax, dword ptr [edi - IDXLSTLIST]              
                    jmp     short @F

    _NextUp:        mov     eax, edx        ;IdxPre        
                    cmp     eax, 0
                    je      short _fim
                    
    @@:             mov     IdxCur, eax
    
                    sub     eax, 1
                    mov     edx, lReg
                    mul     edx
                    add     eax, edi

                    mov     ecx, dword ptr [eax].NODE.iNext         ; Idx Next
                    mov     edx, dword ptr [eax].NODE.iPrev         ; Idx Prev

                    add     nNodeUp, 1
                    cmp     ebx, nNodeUp
                    jb      _erro
                    ;
                    cmp     ecx, IdxCur 
                    je      _erro
                    ;
                    cmp     edx, IdxCur 
                    je      _erro

                    cmp     ecx, edx
                    je      _case2
                    jne     short _NextUp

    ;***---***
        _fim:       mov     eax, nNodeDn
                    cmp     eax, nNodeUp
                    jne     _erro
    ;-----------------------------------
    ;         Alloc structure
    ;-----------------------------------    
                    cmp     eax, ebx
                    je      short _full
                    ;
                    mov     edx, dword ptr [edi - IDXALCLIST]          ; Alloc
                    xor     ecx, ecx                                   ; Nodes
                    ;
        _Nxt:       mov     eax, edx
                    cmp     eax, 0
                    jne     short @F
                    ;
                    ; end
                    ; ---
                    mov     eax, nNodeDn
                    add     ecx, eax
                    cmp     ecx, ebx
                    je      short _Ok
                    jne     _erro                     
    ;***---***                    
        @@:         mov     IdxCur, eax
                    ;
                    sub     eax, 1
                    mov     edx, lReg
                    mul     edx
                    add     eax, edi

                    mov     edx, dword ptr [eax].NODE.iNext         ; Idx Next
                    cmp     edx, IdxCur 
                    je      _erro
                    
                    add     ecx, 1              ; number of nodes
                    
                    cmp     ecx, ebx
                    jbe     short _Nxt
                    ja      _erro

    _full:          cmp     dword ptr [edi - IDXALCLIST], 0            ; Alloc
                    jne     _erro                    

    _Ok:            clc
                    
    _end:           pop     edi
                    pop     ebx
                    ret
VerifyLkdList       endp         
;
DeleteLkdList       proc    pLst:DWORD, lReg:DWORD, pStr:DWORD
                    LOCAL   IdxCur, IdxNxt, IdxPre:DWORD
                    
                    push    ebx
                    push    esi
                    push    edi
                    ;
                    mov     esi, pStr
                    mov     edi, pLst

                    call    LenStringN

                    mov     eax, dword ptr [edi - IDXFSTLIST]       ; Idx First
                    cmp     eax, 0
                    jne     short _start
                    ;
                    ; is empty
                    ; --------
                    invoke  MessageBeep, MB_OK
                    stc
                    jmp     _end

        _next:      ;mov     eax, IdxNxt
                    mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next
                    cmp     eax, 0
                    je      _not
                    
        _start:     mov     IdxCur, eax
        
                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi
                    mov     ebx, eax
                    ;
                    ;mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next
                    ;mov     IdxNxt, eax
                    ;mov     edx, dword ptr [ebx].NODE.iPrev         ; Idx Prev
                    ;mov     IdxPre, edx

                    call    CmpStrings
                    ja      short _next
                    jb      short _not
                    ;
                    ; is this
                    ; -------
                    mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next
                    mov     IdxNxt, eax
                    mov     edx, dword ptr [ebx].NODE.iPrev         ; Idx Prev
                    mov     IdxPre, edx
                    ;
                    mov     edx, dword ptr [edi - IDXALCLIST]            ; Alloc                    
                    mov     eax, IdxCur                    
                    mov     dword ptr [edi - IDXALCLIST], eax            ; Alloc
                    mov     dword ptr [ebx].NODE.iNext, edx              ; Idx Next
                    ;
                    mov     eax, IdxPre
                    cmp     eax, 0
                    je      _first
                    ;
                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi
                    mov     edx, eax
                    
                    mov     eax, IdxNxt
                    mov     dword ptr [edx].NODE.iNext, eax              ; Idx Next
                    cmp     eax, 0
                    je      _last

                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi

                    mov     edx, IdxPre
                    mov     dword ptr [eax].NODE.iPrev, edx           ; Idx Prev
                    clc
                    jmp     _end
;--------------------
        _last:      mov     eax, IdxPre
                    mov     dword ptr [edi - IDXLSTLIST], eax       ; Idx Last
                    clc
                    jmp     _end
;--------------------
        _first:     mov     eax, IdxNxt                             ; Idx next
                    mov     dword ptr [edi - IDXFSTLIST], eax       ; Idx First
                    cmp     eax, 0
                    je      short @F

                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi

                    mov     dword ptr [eax].NODE.iPrev, 0           ; Idx Prev
                    clc
                    jmp     _end

            @@:     mov     dword ptr [edi - IDXLSTLIST], eax       ; Idx Last
                    clc                    
                    jmp     _end
    ;--------------
    _not:           invoke  MessageBeep, MB_ICONHAND
                    stc
    _end:           pop     edi
                    pop     esi
                    pop     ebx
                    ret
DeleteLkdList       endp        
;
AddStrLkdList       proc    pLst:DWORD, lReg:DWORD, pFld:DWORD, pStr:DWORD
                    push    esi

                    mov     esi, pStr
                    mov     edx, pLst
                    
                    mov     edx, dword ptr [edx - PTRNEWLIST]            ; pReg Cur
                    mov     eax, pFld
                    lea     edx, dword ptr [edx+eax]

        @@:         movzx   eax, byte ptr [esi]                    
                    mov     byte ptr [edx], al
                    add     esi, 1
                    add     edx, 1
                    cmp     al, 0
                    jne     short @B


    _end:           pop     esi
                    ret
AddStrLkdList       endp
;
AddIntLkdList       proc    pLst:DWORD, lReg:DWORD, pFld:DWORD, nInt:DWORD
                    mov     edx, pLst
                    
                    mov     edx, dword ptr [edx - PTRNEWLIST]            ; pReg Cur
                    mov     eax, pFld
                    lea     edx, dword ptr [edx+eax]

                    mov     eax, nInt
                    mov     dword ptr [edx], eax
                    ret
AddIntLkdList       endp
;
InsertLkdList       proc    pLst:DWORD, lReg:DWORD, pStr:DWORD
                    push    ebx
                    push    esi
                    push    edi
                    ;
                    mov     esi, pStr
                    mov     edi, pLst
                    mov     eax, dword ptr [edi - IDXALCLIST]            ; Alloc

                    cmp     eax, 0
                    jne     short @F
                    ;
                    ; Is full
                    ; -------
                    invoke  MessageBeep, MB_ICONEXCLAMATION
                    stc
                    jmp     _end
                    

    @@:             mov     ebx, eax
    
                    sub     eax, 1
                    mov     ecx, lReg
                    mul     ecx
                    add     eax, edi

                    mov     dword ptr [edi - PTRNEWLIST], eax         ; Ptr Reg Cur

                    mov     edx, dword ptr [eax].NODE.iNext
                    mov     dword ptr [edi - IDXALCLIST], edx         ; Alloc

                    mov     dword ptr [eax].NODE.iNext, 0
                    mov     dword ptr [eax].NODE.iPrev, 0

                    call    SetLkdList
                    
                    cmp     dword ptr [edi - IDXFSTLIST], 0           ; Idx First
                    jne     short _next
                    ;
                    ; Is first
                    ; --------
                    mov     dword ptr [edi - IDXFSTLIST], ebx         ; Idx First
                    mov     dword ptr [edi - IDXLSTLIST], ebx         ; Idx Last                    
                    jmp     _end
                    
    _next:          call    CmpLkdList
    
                    clc
    _end:           pop     edi
                    pop     esi
                    pop     ebx
                    ret
InsertLkdList       endp 
;
;       ESI     - pStr    
;       EDI     - pList
;       ECX     - lReg
;
CmpLkdList          proc
                    LOCAL   LenReg, IdxNew, PtrNew, IdxCur, IdxNxt, IdxPre:DWORD

                    mov     PtrNew, eax                             ; Ptr new
                    mov     IdxNew, ebx                             ; Idx new
                    mov     LenReg, ecx                             ; Len Reg

                    call    LenStringN

                    mov     eax, dword ptr [edi - IDXFSTLIST]       ; Idx First
                    jmp     short _start
                    
        _next:      ;mov     eax, IdxNxt
                    mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next        
                    cmp     eax, 0
                    je      _last
                    
        _start:     mov     IdxCur, eax
        
                    mov     edx, LenReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi
                    mov     ebx, eax
                    ;
                    ;mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next
                    ;mov     IdxNxt, eax
                    ;mov     edx, dword ptr [ebx].NODE.iPrev         ; Idx Prev
                    ;mov     IdxPre, edx

                    call    CmpStrings
                    jae     short _next
;--------------------
                    mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next
                    mov     IdxNxt, eax
                    mov     edx, dword ptr [ebx].NODE.iPrev         ; Idx Prev
                    mov     IdxPre, edx                    
;--------------------
                    mov     eax, IdxPre
                    cmp     eax, 0
                    je      _first

                    mov     edx, IdxNew                             ; Idx new
                    mov     dword ptr [ebx].NODE.iPrev, edx         ; Idx Prev

                    mov     edx, IdxCur
                    ;mov     eax, IdxPre
                    
                    mov     ebx, PtrNew                             ; Ptr new
                    mov     dword ptr [ebx].NODE.iNext, edx         ; Idx Next
                    mov     dword ptr [ebx].NODE.iPrev, eax         ; Idx Prev

                    mov     edx, LenReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi

                    mov     edx, IdxNew                             ; Idx new
                    mov     dword ptr [eax].NODE.iNext, edx         ; Idx Next
                    ;ret
                    jmp     _end
;--------------------
        _last:      mov     eax, IdxNew                             ; Idx new
                    mov     dword ptr [edi - IDXLSTLIST], eax       ; Idx Last
                    mov     dword ptr [ebx].NODE.iNext, eax         ; Idx Next

                    mov     eax, IdxCur
                    mov     ebx, PtrNew                             ; Ptr new
                    mov     dword ptr [ebx].NODE.iPrev, eax         ; Idx Prev
                    ;ret
                    jmp     _end
;--------------------
        _first:     mov     eax, IdxNew                             ; Idx new
                    mov     dword ptr [edi - IDXFSTLIST], eax       ; Idx First
                    mov     dword ptr [ebx].NODE.iPrev, eax         ; Idx Prev

                    mov     eax, IdxCur
                    mov     ebx, PtrNew                             ; Ptr new
                    mov     dword ptr [ebx].NODE.iNext, eax         ; Idx Next
                    
        _end:       
                    ret
CmpLkdList          endp
;
LenStringN          proc

                    xor     ecx, ecx
                    jz      short _start
                    
        @@:         add     ecx, 1
        _start:     cmp     byte ptr [esi + ecx], 0
                    jne     short @B

                    ret
LenStringN          endp
;
LenStringX          proc
                    xor     edx, edx
                    jz      short _start
                    
        @@:         add     edx, 1
        _start:     cmp     byte ptr [edi + edx], 0
                    jne     short @B

                    ret
LenStringX          endp
;
;       ESI     - pStr    
;       EDI     - pList
;       ECX     - lReg
;       EBX     - pReg Cur
;
CmpStrings          proc
                    push    ecx
                    push    esi
                    push    edi

                    lea     edi, dword ptr [ebx].NODE.LkdData
                    call    LenStringX
                    ;
                    cmp     ecx, edx
                    jb      short _below
                    ja      short _above     

    ;***---***
    _equal:         movzx   eax, byte ptr [esi]
                    cmp     al, byte ptr [edi]
                    jne     _fim
                    ;
                    add     esi, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short _equal
                    jz      _fim

    ;***---***
    _above:         movzx   eax, byte ptr [esi]
                    cmp     al, byte ptr [edi]
                    jne     _fim
                    ;
                    add     esi, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short _above
                    jz      short _cmp
    ;***---***
    _below:         movzx   eax, byte ptr [esi]
                    cmp     al, byte ptr [edi]
                    jne     _fim
                    ;
                    add     esi, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short _below
        
    _cmp:           cmp     ecx, edx

    _fim:           pop     edi
                    pop     esi
                    pop     ecx
                    ret
CmpStrings          endp
;
;       EAX     - pReg Cur
;
SetLkdList          proc
                    push    eax
                    push    esi
                    
        @@:         movzx   edx, byte ptr [esi]                    
                    mov     byte ptr [eax].NODE.LkdData, dl
                    add     esi, 1
                    add     eax, 1
                    cmp     dl, 0
                    jne     short @B

                    pop     esi                    
                    pop     eax
                    ret
SetLkdList          endp 
;
PutLkdList          proc
                    push    eax
                    push    esi
                    push    edi
                    
                    lea     edi, dword ptr [eax].NODE.LkdData
                    
        @@:         movzx   eax, byte ptr [esi]                    
                    mov     byte ptr [edi], al
                    add     esi, 1
                    add     edi, 1
                    cmp     al, 0
                    jne     short @B
                    
                    pop     edi
                    pop     esi
                    pop     eax                    
                    ret
PutLkdList          endp      
;
CreateLkdList       proc    nReg:DWORD, lReg:DWORD, pBuf:DWORD, pLst:DWORD

                    mov     eax, nReg
                    mov     edx, lReg
                    mul     edx
                    add     eax, 24
                    ;
                    invoke  GlobalAlloc, GMEM_FIXED, eax
                    cmp     eax, NULL
                    jne     short @F
                    stc
                    ret
                    
        @@:         mov     edx, pBuf
                    mov     dword ptr [edx], eax
                    add     eax, 20
                    ;
                    mov     edx, pLst
                    mov     dword ptr [edx], eax
                    ;
                    mov     edx, nReg
                    mov     dword ptr [eax - IDXNODLIST], edx         ; Nodes

                    invoke  FormatLkdList, edx, lReg, eax

                    clc        
                    ret
CreateLkdList       endp
;
FormatLkdList       proc    nReg:DWORD, lReg:DWORD, pLst:DWORD
                    push    ebx
                    push    edi
                    ;
                    mov     edi, pLst
                    
                    mov     dword ptr [edi - IDXALCLIST], 1         ; Alloc
                    mov     dword ptr [edi - IDXFSTLIST], 0         ; Idx First
                    mov     dword ptr [edi - IDXLSTLIST], 0         ; Idx Last
                    ;
                    mov     ecx, nReg
                    sub     ecx, 1
                    ;
                    mov     eax, lReg
                    mul     ecx
                    add     eax, edi
                    mov     dword ptr [eax].NODE.iNext, 0
                    ;
        @@:         mov     ebx, ecx
                    add     ebx, 1
                    ;
                    sub     ecx, 1
                    ;
                    mov     eax, lReg
                    mul     ecx
                    add     eax, edi
                    mov     dword ptr [eax].NODE.iNext, ebx
                    ;
                    cmp     ecx, 0
                    jne     short @B

                    pop     edi
                    pop     ebx
                    ret
FormatLkdList       endp
;
DestroyLkdList      proc    pBuf:DWORD
                    invoke  GlobalFree, pBuf
                    ret
DestroyLkdList      endp
;
;               Procedures to test 
;
SeeLkdList          proc
                    pushad
                    ;
                    mov     edi, pList
                    ;print   str$(edi), 13, 10
                    ;inkey
                    ;
                    mov     ebx, 1
                    
        @@:         push    ebx
                    sub     ebx, 1                    
                    mov     eax, LENNODE
                    mul     ebx
                    add     eax, edi
                    mov     eax, dword ptr [eax].NODE.iNext

                    print   str$(eax), 13, 10
                    inkey
                    ;
                    pop     ebx
                    
                    add     ebx, 1
                    cmp     ebx, 20
                    jbe     @B
                    
                    popad
                    ret
SeeLkdList          endp
;
ShowLkdListUp       proc
                    pushad

                    print   "From BOTTOM to TOP ", 13, 10

                    mov     edi, pList
                    call    ShowHeader
                    
                    mov     ebx, dword ptr [edi - IDXLSTLIST]            ; Idx Last

        _next:      cmp     ebx, 0
                    je      _fim
                    
                    mov     ecx, LENNODE
                    mov     eax, ebx
                    sub     eax, 1
                    mul     ecx
                    add     eax, edi
                    mov     esi, eax
                    ;
                    print   "Cur= "
                    print   str$(ebx)
                    ;
                    print   "   Next= "
                    mov     eax, dword ptr [esi].NODE.iNext
                    print   str$(eax)
                    ;
                    print   "   Prev= " 
                    mov     eax, dword ptr [esi].NODE.iPrev
                    print   str$(eax)
                    ;
                    print   "   String= "
                    lea     ebx, dword ptr [esi].NODE.LkdData
                    print   ebx
                    ;
                    print   "       String 2= "
                    lea     ebx, dword ptr [esi].NODE.StrData
                    print   ebx, 13, 10
                    ;
                    print   "Number= "
                    lea     ebx, dword ptr [esi].NODE.IntData
                    mov     eax, dword ptr [ebx]
                    print   str$(eax), 13, 10
                    
                    mov     ebx, dword ptr [esi].NODE.iPrev                    
                    jmp     _next
                    

        _fim:       ;inkey
                    print   "----------------------------------------------", 13, 10        
                    ;print   "  ", 13, 10

                    popad
                    ret
ShowLkdListUp       endp
;
ShowLkdListDn       proc
                    pushad

                    print   "----------------------------------------------", 13, 10
                    print   "From TOP to BOTTOM ", 13, 10

                    mov     edi, pList
                    call    ShowHeader

                    mov     ebx, dword ptr [edi - IDXFSTLIST]            ; Idx First
                    
        _next:      cmp     ebx, 0
                    je      _fim
                    
                    mov     ecx, LENNODE
                    mov     eax, ebx
                    sub     eax, 1
                    mul     ecx
                    add     eax, edi
                    mov     esi, eax
                    ;
                    print   "Cur= "
                    print   str$(ebx)
                    ;
                    print   "   Next= "
                    mov     eax, dword ptr [esi].NODE.iNext
                    print   str$(eax)
                    ;
                    print   "   Prev= " 
                    mov     eax, dword ptr [esi].NODE.iPrev
                    print   str$(eax)
                    ;
                    print   "   String Lkd= "
                    lea     ebx, dword ptr [esi].NODE.LkdData
                    print   ebx
                    ;
                    print   "       String 2= "
                    lea     ebx, dword ptr [esi].NODE.StrData
                    print   ebx, 13, 10
                    ;
                    print   "          Number= "
                    lea     ebx, dword ptr [esi].NODE.IntData
                    mov     eax, dword ptr [ebx]
                    print   str$(eax), 13, 10

                    mov     ebx, dword ptr [esi].NODE.iNext                    
                    jmp     _next
                    
        _fim:       ;inkey
                    print   " ", 13, 10

                    popad
                    ret
ShowLkdListDn       endp
;
VerifyList          proc
                    pushad
                    
                    invoke  VerifyLkdList, pList, sizeof NODE
                    jnc     short @F
                    ;
                    print   "====================================", 13, 10
                    print   "**********LINKED LIST ERROR*********", 13, 10
                    print   "====================================", 13, 10                    
                    jmp     _end
                    ;
        @@:         mov     ebx, eax

                    print   "====================================", 13, 10
                    print   "Nodes= "
                    print   str$(ebx), 13, 10
                    print   "************** correct *************", 13, 10
                    print   "====================================", 13, 10

        _end:       inkey

                    popad
                    ret
VerifyList          endp
;
ShowHeader          proc

                    print   "Alloc= "
                    mov     eax, dword ptr [edi - IDXALCLIST]            ; Alloc
                    print   str$(eax), 13, 10

                    print   "First= "
                    mov     eax, dword ptr [edi - IDXFSTLIST]            ; Idx First
                    print   str$(eax), 13, 10
                    ;
                    print   "Last= "
                    mov     eax, dword ptr [edi - IDXLSTLIST]            ; Idx Last
                    print   str$(eax), 13, 10
                    ;
                    ret
ShowHeader          endp
;
ShowAlloc           proc
                    pushad

                    print   "**********************************************", 13, 10
                    print   "Alloc structure ", 13, 10

                    mov     edi, pList
                    
                    print   "Alloc= "
                    mov     ebx, dword ptr [edi - IDXALCLIST]            ; Alloc
                    print   str$(ebx), 13, 10
                    ;
        _next:      cmp     ebx, 0
                    je      _end

                    mov     ecx, LENNODE
                    mov     eax, ebx
                    sub     eax, 1
                    mul     ecx
                    add     eax, edi
                    mov     esi, eax
                    ;
                    print   "Cur= "
                    print   str$(ebx)

                    print   "   Next Alloc= "
                    mov     ebx, dword ptr [esi].NODE.iNext                    
                    print   str$(ebx), 13, 10
                    jmp     _next


        _end:       
                    print   "**********************************************", 13, 10

                    inkey
        
                    popad
                    ret
ShowAlloc           endp
;
end start
